#include <cassert>
#include <cstdio>                                           // for rename()
#include <cstdlib>                                          // for system()
#include <ctime>                                        // in prn_results()
#include <fstream>
#include <getopt.h>                                         // for getopt()
#include <iomanip>
#include <iostream>
#include <libgen.h>                                       // for basename()
#include <limits>                                         // for xmax, xmin
#include <sstream>
#include <vector>
// #include <unistd.h>                                      // for getopt()

using namespace std;


typedef  const int      cint;
typedef  unsigned       uns;
typedef  double         dbl;
typedef  const double   cdbl;
typedef  const string   cstring;
typedef  istringstream  isstream;
typedef  ostringstream  osstream;
typedef  vector<dbl>    dvec;

enum no_yes {no, yes};

struct opts {
    int sigmas;              // yes if independent sigmas supplied in col 3
};

//
// prototypes
//
void trimspace(string&);
void gopen(ifstream& ifs, cstring fname);
void gopen(ofstream& ofs, cstring fname);
void err(cstring);
void warn(cstring);
void err(cstring, cstring);
void err(cstring, cstring, cstring);
void err(cstring, int);
void err(cstring, string::size_type);
void err(cstring, int, cstring);
void get_data(ifstream& ifs, dvec& x, dvec& y, dvec& s);// (x,y)=pt, s=sigma
void get_opts(int, char**, opts&);
void gsystem(cstring cmd);
void prn_usage(char**);
void prn_info(char**);
void mk_graph(string, opts&);
string get_string(cstring, cstring, uns);

void  error_exit_cannot_get_here(const string fname, cint line_no);
void  gstrftime(string& s, cstring format, const struct tm* tm);
